/* Copyright (C) 1991, 1992, 1994, 1997, 2008 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.
*/

/* Save the current program position in ENV and return 0.  */
	.text
	.globl __sigsetjmp
__sigsetjmp:
	stw r16, 0(r4)
	stw r17, 4(r4)
	stw r18, 8(r4)
	stw r19, 12(r4)
	stw r20, 16(r4)
	stw r21, 20(r4)
	stw r22, 24(r4)
	stw r23, 28(r4)
	stw sp, 32(r4)
	stw fp, 36(r4)
	stw ra, 40(r4)
#if defined NOT_IN_libc && defined IS_IN_rtld
	/* In ld.so we never save the signal mask.  */
	mov r2, zero
	ret
#else
	/* Save the signal mask if requested.  */
#if defined(__PIC__) || defined(PIC)
        nextpc r2
1:	movhi r3, %hiadj(_GLOBAL_OFFSET_TABLE_ - 1b)
	addi r3, r3, %lo(_GLOBAL_OFFSET_TABLE_ - 1b)
	add r2, r2, r3
	ldw r2, %call(__sigjmp_save)(r2)
	jmp r2
#else
	jmpi __sigjmp_save
#endif
#endif

libc_hidden_def (__sigsetjmp)
